const alphabet = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'å', 'ä', 'ö']
const consonants = ['b', 'c', 'd', 'f', 'g', 'h', 'j', 'k', 'l', 'm', 'n', 'p', 'q', 'r', 's', 't', 'v', 'w', 'x', 'z']
const conjunctions = [" ja ", " sekä ", " että ", " eli ", " tai ", " joko ", " vai ", " mutta ", " vaan ", " siksi ", " siis ", " sillä ", " näet ", " nimittäin ", " jotta ", " koska ", " kun ", " jos ", " vaikka ", " kuin ", " kunnes ", " jopa "]
const beVerbs = [" olen ", " olet ", " on ", " olemme ", " olette ", " ovat ", " ollaan ", " olla "]
counter = 0

// Shiftaa kaikki lauseet ja palauttaa listan listoja, joissa alilista on aina yhden lauseen kaikki 29 shiftaus vaihtoehtoa
async function getAllPossibilities(data){
    let text = data.toString().toLowerCase()
    let arrayOfPossibilities = []
    arrayOfPossibilities.push({'text': text, 'isFinnish': await onkoSuomea(text), 'isOrig': true, 'shiftState': 0, 'id': counter})
    counter++
    for(let i=1; i<29; i++){
        let shiftedText = await shiftLeft(text, i)
        let textObject = {
            'text': shiftedText, 
            'isFinnish': await onkoSuomea(shiftedText), 
            'isOrig': false,
            'shiftState': i,
            'id': counter
        }
        counter++
        arrayOfPossibilities.push(textObject)
    }
    return arrayOfPossibilities
}

// Apufunktio lauseiden shiftaamiseen
async function shiftLeft(text, shiftAmount){
    let uusi = "";
    for(let i=0; i<text.length; i++){
        let c = text[i];
        if(c==='.' || c===' '){
            uusi = uusi + c;
        }
        else{
            uusi = uusi + alphabet[await shiftHelper(alphabet.indexOf(c), shiftAmount)];
        }
    }
    return uusi;
}

// Varmistaa, että shiftaus ei mene yli aakkoston
async function shiftHelper(charLoc, shiftAmount){
    let result = charLoc - shiftAmount;
    //console.log("result: "+result);

    if(result>=0){
        return result;
    }
    else{
        return 29 + result;
    }
}

// Funktio, jolla tarkistetaan onko lause suomea vai jotakin muuta
async function onkoSuomea(text){
    /*let previousChar = '0'
    let previousChar2 = '0'

    for(let i=0; i<text.length; i++){
        let currentChar = text.charAt(i);
        //console.log(currentChar)
        //console.log("Chars: "+currentChar+previousChar+previousChar2);
        if(previousChar === '0' && previousChar2 === '0'){
            previousChar = currentChar;
        }
        else if(previousChar !== '0' && previousChar2 === '0'){
            previousChar2 = previousChar;
            previousChar = currentChar;
        }
        else{
            let totuus = await check3Consonants(currentChar, previousChar, previousChar2)
            console.log("Mitä funktio palauttaa: "+totuus)
            if(totuus){
                console.log("KOLME peräkkäistä konsonanttia "+ currentChar,previousChar, previousChar2)
                return false;
            }
            previousChar2 = previousChar;
            previousChar = currentChar;
        }
    }*/
    //comment
    if(await checkConjunctions(text) || await checkBeVerbs(text)){
        return true
    }
    //console.log("Päästään loppuun JEEEEE")
    return false;
}

async function checkConjunctions(text){
    for(let s of conjunctions){
        if(text.includes(s)){
            //console.log(s);
            return true;
        }
    }
}

async function checkBeVerbs(text){
    for(let s of beVerbs){
        if(text.includes(s)){
            //console.log(s);
            return true;
        }
    }
}

async function check3Consonants( a, b, c){
    //console.log("3 consonants")
    //console.log(consonants.includes(a, b, c))
    let totuus = await consonants.includes(a && b && c)
    console.log("löytyykö kolme konsonanttia: "+totuus)
    if(totuus){
        return true;
    }
    else{
        return false;
    }
}


module.exports = {
    getAllPossibilities
}